package com.cf.imes.module.executor.service.order;

import javax.servlet.http.HttpServletResponse;
import javax.validation.*;

import com.alibaba.fastjson.JSONObject;
import com.cf.imes.module.executor.controller.admin.order.vo.order.*;
import com.cf.imes.module.executor.controller.admin.order.vo.product.OrderBodyRespVO;
import com.cf.imes.module.executor.controller.admin.orderParts.vo.OrderPartsRespVO;
import com.cf.imes.module.executor.controller.admin.plate.vo.PlateRespVO;
import com.cf.imes.module.executor.dal.dataobject.goods.GoodsDO;
import com.cf.imes.module.executor.dal.dataobject.order.OrderDO;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.module.executor.dal.dataobject.orderBody.OrderBodyDO;
import com.cf.imes.module.executor.dal.dataobject.orderModuleExtra.OrderModuleExtraDO;
import com.cf.imes.module.executor.dal.dataobject.plate.PlateDO;
import org.springframework.boot.system.ApplicationHome;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 生产单表 order_{N} Service 接口
 *
 * @author 晨丰科技
 */
public interface OrderService {

    /**
     * 创建生产单表 order_{N}
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createOrder(@Valid OrderSaveReqVO createReqVO);

    /**
     * 更新生产单表 order_{N}
     *
     * @param updateReqVO 更新信息
     */
    void updateOrder(@Valid OrderSaveReqVO updateReqVO);

    /**
     * 作废生产单表 order_{N}
     *
     * @param orderId 编号组
     */
    void deleteOrder(Long orderId);

    /**
     * 还原生产单表 order_{N}
     *
     * @param orderId 编号组
     */
    void restoreOrder(Long orderId);

    /**
     * 获得生产单表 order_{N}
     *
     * @param id 编号
     * @return 生产单表 order_{N}
     */
    OrderDO getOrder(Long id );

    /**
     * 获得生产单表 order_{N}分页
     *
     * @param pageReqVO 分页查询
     * @return 生产单表 order_{N}分页
     */
    PageResult<OrderDO> getOrderPage(OrderPageReqVO pageReqVO);

    /**
     * @param orderId: 生产单Id
     * @return List<OrderBodyRespVO>
     */
    List<OrderBodyRespVO> getOrderBody(Long orderId);

    /**
     * @param orderId: 生产单Id
     * @return Map<String, List<?>>
     */
    Map<String,List<?>> getModule(Long orderId);

    /**
     * @param orderId: 生产单id
     * @param roomId: 房间id
     * @param bodyId: 柜体id
     * @return List<OrderPlatesDetailReqVO>
     *     需要修改返回值
     */
    List<OrderPlatesDetailReqVO> getPlatesDetail(Long orderId, Long roomId , Long bodyId , Long groupId, String groupName);

    /**
     * @param orderId: 生产单id
     * @param roomId: 房间id
     * @param bodyId: 柜体id
     * @return List<OrderPartsRespVO>
     *     需要修改返回值
     */
    List<OrderPartsRespVO> getPartsDetail(Long orderId, Long roomId , Long bodyId , String name);

    /**
     * 删除柜体
     * @param orderId: 生产单id
     * @param bodyIds: 柜体id
     */
    void deleteBodyByOrder(Long orderId , Collection<Long> bodyIds);

    /**
     * @param orderId:
      * @return Object
     * @author Administrator
     * @date 2024/3/30
     */
    List<OrderBodyDO> getBody(Long orderId);

    /**
     * @param listMap：生产单号
     * @return Boolean
     * @author Administrator
     * @date 2024/3/30
     */
    Long importApiData(Map<String, List<?>> listMap);

    /**
     * @param orderId: 生产单Id
     * @return List<GoodsDO>
     */
    List<GoodsDO> getGoodsList(Long orderId);

    /**
     * 文件数据导入
     */
    void importExcelData(OrderDO orderDO, List<?> list);

    /**
     * 模板文件导入保存
     */
    String importTemplate(MultipartFile file,Boolean type);

    /**
     * 生产导入文件模板下载
     */
    void exportTemplate(HttpServletResponse response, String value);

    /**
     * 打印/导出数据获取 （单文件）
     */
    Map<String, Object> getPrintDataMap(Long orderId, String type,HttpServletResponse response) ;

    default String getSavePath() {
        ApplicationHome applicationHome = new ApplicationHome(this.getClass());

        // 保存目录位置根据项目需求可随意更改
        return applicationHome.getDir().getParentFile()
                .getParentFile().getAbsolutePath() + "\\src\\main\\resources\\type";
    }

}